VERSION 5.00
Begin VB.UserControl SysTray 
   ClientHeight    =   525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   810
   InvisibleAtRuntime=   -1  'True
   Picture         =   "SysTray.ctx":0000
   ScaleHeight     =   35
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   54
   ToolboxBitmap   =   "SysTray.ctx":0BEA
End
Attribute VB_Name = "SysTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'By Leandro Ascierto

Option Explicit

Private Type NOTIFYICONDATA
   cbSize As Long
   hwnd As Long
   uID As Long
   uFlags As Long
   uCallbackMessage As Long
   hIcon As Long
   szTip As String * 128
   dwState As Long
   dwStateMask As Long
   szInfo As String * 256
   uTimeout As Long
   szInfoTitle As String * 64
   dwInfoFlags As Long
End Type

Dim nf_IconData As NOTIFYICONDATA

Const NOTIFYICON_VERSION = 3
Const NOTIFYICON_OLDVERSION = 0
Const NIM_ADD = &H0
Const NIM_MODIFY = &H1
Const NIM_DELETE = &H2
Const NIM_SETFOCUS = &H3
Const NIM_SETVERSION = &H4
Const NIF_MESSAGE = &H1
Const NIF_ICON = &H2
Const NIF_TIP = &H4
Const NIF_STATE = &H8
Const NIF_INFO = &H10
Const NIS_HIDDEN = &H1
Const NIS_SHAREDICON = &H2

Public Enum Mensage
    NIIF_NONE = &H0
    NIIF_INFO = &H1
    NIIF_WARNING = &H2
    NIIF_ERROR = &H3
    NIIF_GUID = &H4
End Enum

Const WM_MOUSEMOVE = &H200
Const WM_LBUTTONDOWN = &H201
Const WM_LBUTTONUP = &H202
Const WM_LBUTTONDBLCLK = &H203
Const WM_RBUTTONDOWN = &H204
Const WM_RBUTTONUP = &H205
Const WM_RBUTTONDBLCLK = &H206
 
Const IDANI_OPEN = &H1
Const IDANI_CLOSE = &H2
Const IDANI_CAPTION = &H3
    
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Const SW_SHOWNORMAL = 1

Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DrawAnimatedRects Lib "user32" (ByVal hwnd As Long, ByVal idAni As Long, lprcFrom As RECT, lprcTo As RECT) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long

Event DblClick(Button As Integer)
Event MouseUp(Button As Integer)
Event MouseDown(Button As Integer)

Dim m_Icon As StdPicture



Public Function ActivateWindows(Caption As String) As Boolean
Dim handle As Long
handle = FindWindow("ThunderFormDC", Caption)
If handle = 0 Then handle = FindWindow("ThunderRT6FormDC", Caption)
Dim rDest As RECT
GetWindowRect handle, rDest
DrawAnimatedRects handle, IDANI_CLOSE Or IDANI_CAPTION, GetTrayRec, rDest
ShowWindow handle, SW_SHOWNORMAL
DoEvents
ActivateWindows = SetForegroundWindow(handle)

End Function

Private Function GetTrayRec() As RECT
Dim handle As Long, ScreenWidth As Long, ScreenHeight As Long

handle = FindWindow("Shell_TrayWnd", vbNullString)
handle = FindWindowEx(handle, ByVal 0&, "TrayNotifyWnd", vbNullString)

If GetWindowRect(handle, GetTrayRec) = 0 Then
    ScreenWidth = Screen.Width / Screen.TwipsPerPixelX
    ScreenHeight = Screen.Height / Screen.TwipsPerPixelY
    SetRect GetTrayRec, ScreenWidth, ScreenHeight, ScreenWidth, ScreenHeight
End If

End Function
Public Sub AnimateWindow(Frm As Object)
Dim rDest As RECT, ScreenWidth As Long, ScreenHeight As Long

    GetWindowRect Frm.hwnd, rDest
    Frm.Visible = False
    DrawAnimatedRects Frm.hwnd, IDANI_CLOSE Or IDANI_CAPTION, rDest, GetTrayRec

End Sub
Public Sub AgregarIcono(Icon As StdPicture, Optional ToolTipText As String)
    With nf_IconData
        .cbSize = Len(nf_IconData)
        .hwnd = UserControl.hwnd
        .uID = vbNull
        .uFlags = NIF_ICON Or NIF_INFO Or NIF_MESSAGE Or NIF_TIP
        .uCallbackMessage = WM_MOUSEMOVE
        .hIcon = Icon
        .szTip = IIf(ToolTipText <> "", ToolTipText, App.EXEName) & vbNullChar
        .dwState = 0
        .dwStateMask = 0
   End With
    Set m_Icon = Icon
   Shell_NotifyIcon NIM_ADD, nf_IconData 'NIM_ADD Agregamos el icono a la barra
End Sub

Public Sub MostrarGlobo(Texto As String, MsgStyle As Mensage, Optional Title As String)
    With nf_IconData
        .hIcon = m_Icon
        .szInfo = Texto & Chr(0) 'Texto del globo
        .szInfoTitle = IIf(Title <> "", Title, App.EXEName) & Chr(0) 'Titulo del globo
        .dwInfoFlags = MsgStyle  'Selecionamos el tipo globo, de informacion en este caso)(NIIF_NONE, NIIF_INFO, NIIF_WARNING, NIIF_ERROR)
        .uTimeout = 1 'Tiempo de espera  (millisec.)
   End With
 
   Shell_NotifyIcon NIM_MODIFY, nf_IconData 'Activamos el globo
End Sub

Public Sub CambiarIcono(ico As StdPicture)
    nf_IconData.hIcon = ico
    nf_IconData.szInfo = Chr(0)
    Set m_Icon = ico
   Shell_NotifyIcon NIM_MODIFY, nf_IconData 'Activamos el globo
End Sub

Public Sub QuitarIcono()
 Shell_NotifyIcon NIM_DELETE, nf_IconData 'NIM_DELETE Quitar el icono de la barra
End Sub




Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)

Select Case x
    Case WM_LBUTTONDOWN
        RaiseEvent MouseDown(1)
    Case WM_RBUTTONDOWN
        RaiseEvent MouseDown(2)
    Case WM_LBUTTONUP
        RaiseEvent MouseUp(1)
    Case WM_RBUTTONUP
        RaiseEvent MouseUp(2)
    Case WM_LBUTTONDBLCLK
        RaiseEvent DblClick(1)
    Case WM_RBUTTONDBLCLK
        RaiseEvent DblClick(2)
End Select

End Sub

Private Sub UserControl_Resize()
UserControl.Width = 810
UserControl.Height = 525
End Sub


Private Sub UserControl_Terminate()
    Shell_NotifyIcon NIM_DELETE, nf_IconData
End Sub

